<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Support\Facades\Auth;

/**
 * @property  string $uuid,
 * @property  float $snap_salary_rate,
 * @property  float $snap_salary_value,
 * @property  float $snap_salary_fund_percent,
 * @property  string $period,
 * @property  int $salary_sheet_id,
 * @property  int $user_id,
 * @property  int $classroom_id
 * @property float $snap_salary_kpi
 * @property float $fund_value
 * @property float $total_value
 * @property mixed $close_details;
 * @property mixed $branch
 * @property bool $is_close
 */
class SalarySnap extends Model
{
    use HasFactory;

    protected $table = 'salary_snap';
    protected $guarded = ['id'];
    protected $appends = [
        'snap_salary_kpi',
        'snap_salary_kpi',
        'fund_value',
        'total_value',
        'is_close',
        'classroom_entity'
    ];

    private Collection $close_details;
    private float $total_value;

    private bool $is_close;

    public static function makeUUID($branch)
    {
        $cardId = SalarySnap::query()->withoutGlobalScopes()->orderBy('id', 'desc')->first()?->id ?? 0;

        $uuid = $cardId < 1000
            ? sprintf('%04d', $cardId + 1)
            : sprintf('%07d', $cardId + 1);

        return $branch . "-" . "Salary" . "." . $uuid;
    }

    /**
     * @return Collection
     */
    public function SalarySnapDetails($close = null): Collection
    {
        if ($close) {
            return $this->close_details;
        }

        return SalarySnapDetail::query()->where([
            'user_id' => $this->user_id,
            'salary_sheet_id' => $this->salary_sheet_id,
        ])->get();
    }

    public function User(): BelongsTo
    {
        return $this->belongsTo(User::class, 'user_id', 'id');
    }

    public function getSnapSalaryKpiAttribute(): int
    {
        $salaryKpi = 0;

        /**
         * @var SalarySnapDetail $salarySnapDetail
         */
        foreach ($this->SalarySnapDetails() as $salarySnapDetail) {
            $salaryKpi += $salarySnapDetail->getAmountAttribute();
        }

        return $salaryKpi;
    }

    public function getFundValueAttribute(): float|int
    {
        return $this->snap_salary_fund_percent * $this->snap_salary_value / 100;
    }

    public function getTotalValueAttribute($close = null): float
    {
        if ($close) {
            return $this->total_value;
        }
        return $this->snap_salary_value + $this->snap_salary_kpi - $this->fund_value;
    }

    public function getIsCloseAttribute(): bool
    {
        return Salary::query()->where('uuid', $this->uuid)->exists();
    }

    public function getClassroomEntityAttribute()
    {
        $classroom = $this->Classroom()?->first() ?? null;
        if (!$classroom) {
            return null;
        }

        return [
            'id' => $classroom->id,
            'name' => $classroom->name,
            'uuid' => $classroom->uuid,
            'avatar' => $classroom->avatar
        ];
    }

    public function Classroom()
    {
        return $this->belongsTo(Classroom::class, 'classroom_id', 'id');
    }

    protected static function boot()
    {
        parent::boot(); // TODO: Change the autogenerated stub
        static::addGlobalScope('branch', function (Builder $builder) {
            $builder->where('branch', Auth::user()->{'branch'});
        });
    }
}
